// #autoload
// #name = FlagCircle
// #version = 1.2
// #date = 14 February, 2003
// #author = ilys
// #description = Two coloured circles, one for each team. Changes colour, from green(home) to red(taken) and flashes red/green(dropped).
// #category = ilys' Scripts
// #status = release
// #include = support/callback.cs
// #include = support/flag_tracker.cs
// #include = support/player_support.cs
// #include = support/mission_callbacks.cs

package FlagCircle {
function PlayGui::onWake(%this) {
	callback.add(onCTFGrab, FlagCircleFlagTaken);
	callback.add(onCTFCap, FlagCircleFlagReturn);
	callback.add(onCTFDrop, FlagCircleFlagDrop);
	callback.add(onCTFPicked, FlagCircleFlagTaken);
	callback.add(onCTFReturn, FlagCircleFlagReturn);
	callback.add(onMissionEnd, FlagCircleMissionEnd);
	callback.add(onGameOver, FlagCircleMissionEnd);
	callback.add(MyTeamChanged, FlagCircleTeamChange);
	callback.add(onUserClientDrop, FlagCircleDrop);
	parent::onWake(%this);

	if(!isObject(PlayGui)) return;

	if (isObject(YourFlagCircle)) return;
	new GuiBitmapCtrl(YourFlagCircle) {
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "25 25";
		minExtent = "8 8";
		visible = "0";
		bitmap = "gui/hud_flag_home.png";
	};

	if (isObject(EnemyFlagCircle)) return;
	new GuiBitmapCtrl(EnemyFlagCircle) {
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "25 25";
		minExtent = "8 8";
		visible = "0";
		bitmap = "gui/hud_flag_home.png";
	};

	playGui.add(YourFlagCircle);
	playGui.add(EnemyFlagCircle);
	if(isObject(HM) && isObject(HudMover))
	{
		hudmover::addhud(YourFlagCircle,"FlagCircleYours");
		hudmover::addhud(EnemyFlagCircle,"FlagCircleEnemy");
	}
}

function FlagCircleMissionEnd()
{
	if ($circleyourcolorswapSchedule != 0) cancel($circleyourcolorswapSchedule);
	if ($circleenemycolorswapSchedule != 0) cancel($circleenemycolorswapSchedule);
	YourFlagCircle.setbitmap("gui/hud_flag_home.png");
	EnemyFlagCircle.setbitmap("gui/hud_flag_home.png");
}

function FlagCircleDrop(%clientName, %clientID)
{
	if ($circleyourcolorswapSchedule != 0) cancel($circleyourcolorswapSchedule);
	if ($circleenemycolorswapSchedule != 0) cancel($circleenemycolorswapSchedule);
	if (isObject(YourFlagCircle))
	{
		playGui.remove(YourFlagCircle);
		YourFlagCircle.delete();
	}
	if (isObject(EnemyFlagCircle))
	{
		playGui.remove(EnemyFlagCircle);
		EnemyFlagCircle.delete();
	}
}

function FlagCircleFlagDrop(%flagref)
{
	%myname = PlayerList.getMyName();
	%myteam = PlayerList.getTeamByName(%myname);
	%flagteam = %flagref.teamID;
	if(%flagteam == %myteam)
	{
		circleyourcolorswapcycle();
	}
	if(%flagteam != %myteam && %myteam != 0)
	{
		circleenemycolorswapcycle();
	}
}

function FlagCircleFlagTaken(%flagref)
{
	%myname = PlayerList.getMyName();
	%myteam = PlayerList.getTeamByName(%myname);
	%flagteam = %flagref.teamID;
	if(%flagteam == %myteam)
	{
		if ($circleyourcolorswapSchedule != 0) cancel($circleyourcolorswapSchedule);
		YourFlagCircle.setbitmap("gui/hud_flag_taken.png");
	}
	if(%flagteam != %myteam && %myteam != 0)
	{
		if ($circleenemycolorswapSchedule != 0) cancel($circleenemycolorswapSchedule);
		EnemyFlagCircle.setbitmap("gui/hud_flag_taken.png");
	}
}

function FlagCircleFlagReturn(%flagref)
{
	%myname = PlayerList.getMyName();
	%myteam = PlayerList.getTeamByName(%myname);
	%flagteam = %flagref.teamID;
	if(%flagteam == %myteam)
	{
		if ($circleyourcolorswapSchedule != 0) cancel($circleyourcolorswapSchedule);
		YourFlagCircle.setbitmap("gui/hud_flag_home.png");
	}
	if(%flagteam != %myteam && %myteam != 0)
	{
		if ($circleenemycolorswapSchedule != 0) cancel($circleenemycolorswapSchedule);
		EnemyFlagCircle.setbitmap("gui/hud_flag_home.png");
	}
}

function circleyourcolorswapcycle()
{
	if($circleyourcolorswap == 1)
	{
		$circleyourcolorswap = 0;
		YourFlagCircle.setbitmap("gui/hud_flag_taken.png");
	}
	else
	{
		$circleyourcolorswap = 1;
		YourFlagCircle.setbitmap("gui/hud_flag_home.png");
	}
	if ($circleyourcolorswapSchedule != 0) cancel($circleyourcolorswapSchedule);
	$circleyourcolorswapSchedule = schedule(500, 0, circleyourcolorswapcycle);
}

function circleenemycolorswapcycle()
{
	if($circleenemycolorswap == 1)
	{
		$circleenemycolorswap = 0;
		EnemyFlagCircle.setbitmap("gui/hud_flag_taken.png");
	}
	else
	{
		$circleenemycolorswap = 1;
		EnemyFlagCircle.setbitmap("gui/hud_flag_home.png");
	}

	if ($circleenemycolorswapSchedule != 0) cancel($circleenemycolorswapSchedule);
	$circleenemycolorswapSchedule = schedule(500, 0, circleenemycolorswapcycle);
}

function FlagCircleTeamChange(%teamID)
{
	if ($circleyourcolorswapSchedule != 0) cancel($circleyourcolorswapSchedule);
	if ($circleenemycolorswapSchedule != 0) cancel($circleenemycolorswapSchedule);
	YourFlagCircle.setbitmap("gui/hud_flag_home.png");
	EnemyFlagCircle.setbitmap("gui/hud_flag_home.png");
	if(%teamID != 0)
	{
		YourFlagCircle.setvisible("1");
		EnemyFlagCircle.setvisible("1");
		%myteam = %teamID;
		if(%myteam == 1)
			%enemyteam = 2;
		else
			%enemyteam = 1;

		error(%myteam);
		error(%enemyteam);
		%myflag = FlagTracker.team[%myteam];
		%enemyflag = FlagTracker.team[%enemyteam];
		if(%myflag.stateCurrent $= "At Home")
		{
			YourFlagCircle.setbitmap("gui/hud_flag_home.png");
		}
		else if(%myflag.stateCurrent $= "Taken")
		{
			YourFlagCircle.setbitmap("gui/hud_flag_taken.png");
		}
		else if(%myflag.stateCurrent $= "In Field")
		{
			circleyourcolorswapcycle();
		}
		if(%enemyflag.stateCurrent $= "At Home")
		{
			YourFlagCircle.setbitmap("gui/hud_flag_home.png");
		}
		else if(%enemyflag.stateCurrent $= "Taken")
		{
			EnemyFlagCircle.setbitmap("gui/hud_flag_taken.png");
		}
		else if(%enemyflag.stateCurrent $= "In Field")
		{
			circleenemycolorswapcycle();
		}
	}
	else
	{
		YourFlagCircle.setvisible("0");
		EnemyFlagCircle.setvisible("0");
	}
}
};
activatePackage(FlagCircle);